configure 16.5 KB
Newer Older
ulrich_y's avatar
ulrich_y committed
1 2 3 4 5 6 7 8 9 10 11 12 13 14
#! /bin/bash
# configure script
# note: has nothing to do with GNU autoconf

exec 2> ${LOGFILE:-/dev/null} 3>&1
eval ${LOGFILE:+set -x}


shopt -s nullglob
export LC_ALL=C

CONF_DIR="${0%/*}"
CONF_OS="`uname -s`"
CONF_MACH="`uname -m`"
ulrich_y's avatar
ulrich_y committed
15 16 17
HAVE_GINAC=false
HAVE_MCC=false
CONF_BITS=
ulrich_y's avatar
ulrich_y committed
18

ulrich_y's avatar
ulrich_y committed
19 20 21 22 23 24 25 26
CONF_FFLAGS=$FFLAGS
CONF_CFLAGS=$CFLAGS
CONF_CPPFLAGS=$CPPFLAGS
CONF_LFLAGS=$LDFLAGS
CONF_FC=$FC
CONF_CC=$CC
CONF_CXX=$CXX
CONF_LD=$LD
ulrich_y's avatar
ulrich_y committed
27
CONF_MODPATH=$FPATH
ulrich_y's avatar
ulrich_y committed
28 29


ulrich_y's avatar
ulrich_y committed
30 31 32 33 34 35
if [ "$CONF_OS" -eq "Darwin" ]; then
    CONF_PREFIX=/usr/local/
else
    CONF_PREFIX=/usr/
fi

ulrich_y's avatar
ulrich_y committed
36
NATIVE=true
ulrich_y's avatar
ulrich_y committed
37 38 39 40 41 42 43 44 45 46
DEBUG=false
for arg in "$@" ; do
    case "$arg" in
        --debug)
            DEBUG=true ;;
        --prefix=*)
            CONF_PREFIX="${arg#--prefix=}" ;;
        --host=*)
            CONF_TARGET="${arg#--host=}" ;;
        --with-ginac)
ulrich_y's avatar
ulrich_y committed
47
            HAVE_GINAC=true ;;
ulrich_y's avatar
ulrich_y committed
48
        --with-mcc)
ulrich_y's avatar
ulrich_y committed
49
            HAVE_MCC=true ;;
ulrich_y's avatar
ulrich_y committed
50 51
        --mmprefix=*)
            CONF_MMPREFIX="${arg#--mmprefix=}" ;;
ulrich_y's avatar
ulrich_y committed
52 53
        --generic)
            NATIVE=false ;;
ulrich_y's avatar
ulrich_y committed
54 55 56 57
        --32)
            CONF_BITS="-m32" ;;
        --64)
            CONF_BITS="-m64" ;;
ulrich_y's avatar
ulrich_y committed
58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80
        -*)
            echo "Warning: $arg is not a valid option." 1>&3 ;;
        *=*)
            eval "$arg" ;;
        *)
            echo "Warning: $arg is not a valid argument." 1>&3 ;;
    esac
done


test=test$$
trap "rm -fr $test* =." 0 1 2 3 15


## look for some programs

findprog() {
    echo -n "looking for $1... " 1>&3
    var="$2"
    set -- ${!var:+"${!var}"} "${@:3}"
    for prog in "$@" ; do
        full="`type -P "$prog"`" && {
            echo "$full" 1>&3
ulrich_y's avatar
ulrich_y committed
81
            printf -v "CONF_$var" "%q" "$full"
ulrich_y's avatar
ulrich_y committed
82 83 84 85 86 87
            return 0
        }
    done
    echo "no $@ in your path" 1>&3
    return 1
}
ulrich_y's avatar
ulrich_y committed
88 89 90 91 92 93 94 95

findlib() {
    echo -n "looking for lib$1... " 1>&3
    for flag in $CONF_LFLAGS ; do
        case "$flag" in
            -L* )
                libfolder=${flag/-L/}
                if [ -f "$libfolder/lib$1.so" ] ; then
ulrich_y's avatar
ulrich_y committed
96
                    path=`readlink -f -- "$libfolder/lib$1.so"`
ulrich_y's avatar
ulrich_y committed
97
                    echo $path 1>&3
ulrich_y's avatar
ulrich_y committed
98
                    printf -v "CONF_$2" "%q" "$path"
ulrich_y's avatar
ulrich_y committed
99 100 101
                    return 0
                fi
                if [ -f "$libfolder/lib$1.a" ] ; then
ulrich_y's avatar
ulrich_y committed
102
                    path=`readlinf -f -- "$libfolder/lib$1.a"`
ulrich_y's avatar
ulrich_y committed
103
                    echo $path 1>&3
ulrich_y's avatar
ulrich_y committed
104
                    printf -v "CONF_$2" "%q" "$path"
ulrich_y's avatar
ulrich_y committed
105 106 107 108 109 110 111 112
                    return 0
                fi
            ;;
        esac
    done
    echo "not found" 1>&3
    return 1
}
ulrich_y's avatar
ulrich_y committed
113
addflag() {
ulrich_y's avatar
ulrich_y committed
114
    eval "CONF_$1=\"\${CONF_$1} ${@:2}\""
ulrich_y's avatar
ulrich_y committed
115 116 117 118 119
}

gnuflags() {
    eval addflag FFLAGS -fdefault-real-8             # default double is 8 byte
    eval addflag FFLAGS -cpp                         # C pre-processor
ulrich_y's avatar
ulrich_y committed
120
    eval addflag FFLAGS -pedantic-errors -std=f2008  # folow f08 strictly
ulrich_y's avatar
ulrich_y committed
121 122
    eval addflag FFLAGS -J build                     # where to put mods
    eval addflag FFLAGS -Werror -Wall                # make every warning an error
ulrich_y's avatar
ulrich_y committed
123
    eval addflag FFLAGS -Wno-uninitialized
ulrich_y's avatar
ulrich_y committed
124
    eval addflag FFLAGS -ffree-line-length-0
ulrich_y's avatar
ulrich_y committed
125 126
}

ulrich_y's avatar
ulrich_y committed
127

ulrich_y's avatar
ulrich_y committed
128 129 130
if [ -z $FC ]; then
    findprog fortran FC  ifort gfortran  || exit 1
fi
ulrich_y's avatar
ulrich_y committed
131 132


ulrich_y's avatar
ulrich_y committed
133
set -- `eval $CONF_FC --version -c | sed '/^$/d;s/([^)]*)//;q' 2>&1`
ulrich_y's avatar
ulrich_y committed
134 135
case "$1,$2,$3" in
    GNU,Fortran,[123].*)
136
        echo "Only version >= 4 are supported" 1>&3
ulrich_y's avatar
ulrich_y committed
137 138
        exit
    ;;
ulrich_y's avatar
ulrich_y committed
139
    GNU,Fortran,4.*)
140
    echo "Code optimisation is *not* suported on gfortran 4" 1>&3
ulrich_y's avatar
ulrich_y committed
141
        gnuflags
ulrich_y's avatar
ulrich_y committed
142
        eval addflag $CONF_BITS
ulrich_y's avatar
ulrich_y committed
143 144
        if $DEBUG ; then
            eval addflag FFLAGS -g -O0
ulrich_y's avatar
ulrich_y committed
145
            eval addflag FFLAGS -ffpe-trap=invalid,overflow
ulrich_y's avatar
ulrich_y committed
146 147 148 149 150
            eval addflag FFLAGS -fdump-core -fbacktrace
            eval addflag FFLAGS -frange-check
            eval addflag FFLAGS -DDEBUG
        else
            eval addflag FFLAGS -DRELEASE
ulrich_y's avatar
ulrich_y committed
151
            $NATIVE && eval addflag FFLAGS -march=native -mtune=native
ulrich_y's avatar
ulrich_y committed
152 153 154 155 156
        fi
    ;;
    GNU,Fortran,*)
        gnuflags
        eval addflag FFLAGS -Wno-maybe-uninitialized
ulrich_y's avatar
ulrich_y committed
157
        eval addflag $CONF_BITS
ulrich_y's avatar
ulrich_y committed
158 159
        if $DEBUG ; then
            eval addflag FFLAGS -g -O0
ulrich_y's avatar
ulrich_y committed
160
            eval addflag FFLAGS -ffpe-trap=invalid,overflow
ulrich_y's avatar
ulrich_y committed
161 162 163 164 165
            eval addflag FFLAGS -fdump-core -fbacktrace
            eval addflag FFLAGS -fcheck=all -frange-check
            eval addflag FFLAGS -DDEBUG
        else
            eval addflag FFLAGS -DRELEASE -O3
ulrich_y's avatar
ulrich_y committed
166
            $NATIVE && eval addflag FFLAGS -march=native -mtune=native
ulrich_y's avatar
ulrich_y committed
167 168 169 170 171 172 173
        fi
    ;;
    ifort*)
        eval addflag FFLAGS -autodouble
        eval addflag FFLAGS -module build
        eval addflag FFLAGS -fpp
        eval addflag FFLAGS -stand f03
ulrich_y's avatar
ulrich_y committed
174
        eval addflag $CONF_BITS
ulrich_y's avatar
ulrich_y committed
175 176 177 178
        if $DEBUG ; then
            eval addflag FFLAGS -g -O0
            eval addflag FFLAGS -DDEBUG
        else
ulrich_y's avatar
ulrich_y committed
179 180
            eval addflag FFLAGS -DRELEASE -O3 -fast
            $NATIVE && eval addflag FFLAGS -xHost
ulrich_y's avatar
ulrich_y committed
181
        fi
ulrich_y's avatar
ulrich_y committed
182
        if $HAVE_GINAC ; then
183
            echo "Option --with-ginac is incompatible with ifort, disabling" 1>&3
ulrich_y's avatar
ulrich_y committed
184
            HAVE_GINAC=false
ulrich_y's avatar
ulrich_y committed
185
        fi
ulrich_y's avatar
ulrich_y committed
186
        if $HAVE_MCC ; then
187
            echo "Option --with-mcc is incompatible with ifort, disabling" 1>&3
ulrich_y's avatar
ulrich_y committed
188
            HAVE_MCC=false
ulrich_y's avatar
ulrich_y committed
189 190 191
        fi
    ;;
    *)
192
        echo "Unknown compiler" 1>&3
ulrich_y's avatar
ulrich_y committed
193 194 195 196
        exit
    ;;
esac

ulrich_y's avatar
ulrich_y committed
197 198 199 200 201 202 203 204
echo -n "extracting the Fortran libraries... " 1>&3

rm -fr $test*

tee $test.f90 << _EOF_ 1>&2
    program test
    integer i
    common /uscore/ i
ulrich_y's avatar
ulrich_y committed
205
    call exit(i)
ulrich_y's avatar
ulrich_y committed
206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228
    end
_EOF_

while read line ; do
  set -- ${line//[:,()]/ }
  [[ "$1" =~ (/collect2|/ld|^ld)$ ]] && while test $# -gt 1 ; do
    shift
    case "$1" in
    *.o | -lc*)
      ;;
    -l* | -L* | *.a)
      FLDFLAGS+=" $1" ;;
    -Bstatic | -Bdynamic | *.ld)
      FLDFLAGS+=" -Wl,$1" ;;
    /*)
      FLDFLAGS+=" -L$1" ;;
    -rpath*)
      FLDFLAGS+=" -Wl,$1,$2"
      shift ;;
    -dynamic-linker)
      shift ;;
    esac
  done
ulrich_y's avatar
ulrich_y committed
229 230 231 232 233 234 235 236 237 238 239 240

  if [[ "$line" == *"-fintrinsic-modules-path"* ]]; then
    set -- ${line//[:,()]/ }
    while test $# -gt 1 ; do
      shift
      case "$1" in
        -fintrinsic-modules-path )
          CONF_MODPATH=$2
          ;;
      esac
    done
  fi
ulrich_y's avatar
ulrich_y committed
241
done < <(eval $CONF_FC  -v -o $test $test.f90 2>&1)
ulrich_y's avatar
ulrich_y committed
242 243
echo "ok" 1>&3

ulrich_y's avatar
ulrich_y committed
244
eval addflag LFLAGS "$LDFLAGS $CONF_LDFLAGS $FLDFLAGS -L$CONF_PREFIX/lib"
ulrich_y's avatar
ulrich_y committed
245

ulrich_y's avatar
ulrich_y committed
246 247 248 249 250 251 252 253 254 255 256
if [[ ! -z "$CONF_MODPATH" ]]; then
    echo -n "checking whether module path is in prefix... " 1>&3
    if [[ "${CONF_MODPATH##$CONF_PREFIX}" != "${CONF_MODPATH}" ]]; then
        echo " yes" 1>&3
        CONF_MODPATH="${CONF_MODPATH##$CONF_PREFIX}"
    else
        echo " no" 1>&3
        CONF_MODPATH=
    fi
fi

ulrich_y's avatar
ulrich_y committed
257

258
findprog pkg-config PKGCONFIG pkg-config
ulrich_y's avatar
ulrich_y committed
259 260
if [[ -z "$CONF_MODPATH" ]]; then
  if [[ -z "$CONF_PKGCONFIG" ]]; then
261 262 263 264 265 266 267 268 269
    echo "*************************************************" 1>&3
    echo "Warning! pkg-config not found! This may lead to  " 1>&3
    echo "difficulties when you try to compile your own    " 1>&3
    echo "code. You will need to run                       " 1>&3
    echo "                                                 " 1>&3
    echo "  $CONF_FC -I$CONF_PREFIX/include                " 1>&3
    echo "                                                 " 1>&3
    echo "every time.                                      " 1>&3
    echo "*************************************************" 1>&3
ulrich_y's avatar
ulrich_y committed
270
  fi
271
fi
ulrich_y's avatar
ulrich_y committed
272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288

if ( $HAVE_GINAC || $HAVE_MCC ); then
    findprog gcc CC clang gcc || exit 1
    findprog g++ CXX clang++ g++ || exit 1
    eval addflag CFLAGS "-std=c99"

    ## does Fortran append underscores to symbols?

    echo -n "does $CONF_FC append underscores... " 1>&3

    tee $test-c.c << _EOF_ 1>&2
int uscore_ = 95;
int uscore = 59;
_EOF_

    for CONF_BITS in ${CONF_BITS:--m64 -m32} ; do
      eval $CONF_CC $CONF_CFLAGS $CONF_BITS -c $test-c.c 1>&2 || continue
ulrich_y's avatar
ulrich_y committed
289
      eval $CONF_FC  -o $test $test.f90 $test-c.o 1>&2 && break
ulrich_y's avatar
ulrich_y committed
290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309
    done

    ./$test
    case $? in
    95)
      echo "yes" 1>&3
      CONF_NOUNDERSCORE=0 ;;
    59)
      echo "no" 1>&3
      CONF_NOUNDERSCORE=1 ;;
    *)
      echo "error linking Fortran and C" 1>&3
      exit 1 ;;
    esac

else
    $CONF_CC=
    $CONF_CXX=
    $CONF_CFLAGS=
    $CONF_NOUNDERSCORE=
ulrich_y's avatar
ulrich_y committed
310 311
fi

ulrich_y's avatar
ulrich_y committed
312 313 314

if $HAVE_MCC ; then
    PATH=$PATH:/Applications/Mathematica.app/Contents/MacOS/ findprog mathematica MATH math MathKernel math10 math11
ulrich_y's avatar
ulrich_y committed
315
    eval addflag FFLAGS -DHAVE_MM
ulrich_y's avatar
ulrich_y committed
316 317 318 319 320 321 322 323

    # Checking Mathematica system id

    echo -n "what is $CONF_MATH SystemID... " 1>&3

    tee $test.m << _EOF_ 1>&2
        Print["SYSID "<>ToString[\$SystemID]];
        Print["INSTDIR "<>ToString[\$InstallationDirectory]];
ulrich_y's avatar
ulrich_y committed
324
        Print["USERDIR "<>ToString[\$UserBaseDirectory]];
ulrich_y's avatar
ulrich_y committed
325 326 327 328
_EOF_
    $CONF_MATH < $test.m > $test.log
    CONF_MATH_SYS=`cat $test.log | grep "SYSID"   | sed 's/.*SYSID //'`
    CONF_MATH_DIR=`cat $test.log | grep "INSTDIR" | sed 's/.*INSTDIR //'`
ulrich_y's avatar
ulrich_y committed
329 330
    CONF_MATH_USR=`cat $test.log | grep "USERDIR" | sed 's/.*USERDIR //'`
    CONF_MMPREFIX=${CONF_MMPREFIX:=$CONF_MATH_USR/Kernel}
ulrich_y's avatar
ulrich_y committed
331 332 333 334 335 336 337 338 339 340 341 342 343 344 345
    echo  $CONF_MATH_SYS 1>&3


    # Finding mcc
    CONF_COMPAD=$CONF_MATH_DIR/SystemFiles/Links/MathLink/DeveloperKit/$CONF_MATH_SYS/CompilerAdditions/
    PATH=$CONF_COMPAD:$PATH findprog mcc MCC mcc

    echo -n "looking for MLDK directory... " 1>&3
    $CONF_MCC --internals > $test.int
    CONF_MLDK=`cat $test.int | grep "MLDK Directory" | cut -f2 -d":"`
    echo $CONF_MLDK 1>&3

    arch=`cat $test.int | grep "Library Bit Type:" | cut -f2 -d":"` ; \
    CONF_MCC_CFLAGS=`cat $test.int | grep "Compile Flags$arch:" | cut -f2 -d":"`
    CONF_MCC_LFLAGS=`cat $test.int | grep "Linker Libraries" | cut -f2 -d":"`
ulrich_y's avatar
ulrich_y committed
346
    CONF_MCC_LFLAGS="$CONF_LFLAGS $CONF_MCC_LFLAGS"
ulrich_y's avatar
ulrich_y committed
347 348 349 350 351 352 353 354
    cat $test.int | grep "Linker Libraries" | cut -f2 -d":"
    if [ ! -z $CONF_BITS ]; then
        if [ "$CONF_BITS" -ne "$MCC_BITS" ]; then
            echo "mcc wants $MCC_BITS ($arch), $CONF_BITS selected." 1>&3
            exit 1
        fi
    fi

ulrich_y's avatar
ulrich_y committed
355
    if [[ $CONF_MCC_LFLAGS == *"uuid"* ]]; then
ulrich_y's avatar
ulrich_y committed
356 357 358 359 360 361 362 363 364 365
        if ! findlib uuid UUID ; then
            echo -n "improvising uuid... " 1>&3
            CONF_MLIBDIR=$CONF_MATH_DIR/SystemFiles/Libraries/$CONF_MATH_SYS/
            if [ -f $CONF_MLIBDIR/libuuid.a ]; then
                CONF_MCC_LFLAGS="-L$CONF_MLIBDIR $CONF_MCC_LFLAGS"
                echo "okay" 1>&3
            else
                echo "failed" 1>&3
                exit 1
            fi
ulrich_y's avatar
ulrich_y committed
366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401
        fi
    fi

    # Finding MPREP
    PATH=$CONF_COMPAD:$PATH findprog mprep MPREP mprep

    ## can we do MathLink compilations
    echo -n "do we have working MathLink... " 1>&3
    tee $test.tm << _EOF_ 1>&2
:Begin:
:Function: test
:Pattern: Test[i_Integer]
:Arguments: {i}
:ArgumentTypes: {Integer}
:ReturnType: Integer
:End:

#include "mathlink.h"

static int test(const int i) {
  return i + 1;
}

int main(int argc, char **argv) {
  return MLMain(argc, argv);
}
_EOF_
    $CONF_MPREP $test.tm > $test.tm.c
    $CONF_CC $CONF_MCC_CFLAGS $CONF_CFLAGS -c $test.tm.c
    $CONF_CC -o $test.math $test.tm.o $CONF_MCC_LFLAGS
    test -x $test.math && {
        echo "yes" 1>&3
        CONF_ML=1
    } || {
        echo "no" 1>&3
        CONF_ML=0
ulrich_y's avatar
ulrich_y committed
402
        exit 1;
ulrich_y's avatar
ulrich_y committed
403 404
    }
fi
ulrich_y's avatar
ulrich_y committed
405 406


ulrich_y's avatar
ulrich_y committed
407
CONF_LD=${LD:-$CONF_FC}
ulrich_y's avatar
ulrich_y committed
408 409 410


if $HAVE_GINAC ; then
ulrich_y's avatar
ulrich_y committed
411
    eval addflag CPPFLAGS "-std=c++11"
ulrich_y's avatar
ulrich_y committed
412 413 414 415 416 417 418
    if [[ ! -z "$CONF_PKGCONFIG" ]]; then
        echo -n "Does pkg-config know about GiNaC... " 1>&3
        if $CONF_PKGCONFIG --exists ginac ; then
            echo "yes" 1>&3
            eval addflag CPPFLAGS `$CONF_PKGCONFIG --cflags ginac`
            eval addflag LFLAGS `$CONF_PKGCONFIG --libs ginac`
            FOUND_GINAC=true
ulrich_y's avatar
ulrich_y committed
419
            CONF_GINAC=`$CONF_PKGCONFIG --variable=libdir ginac`
ulrich_y's avatar
ulrich_y committed
420 421 422 423 424 425 426 427 428 429 430 431
        else
            echo "no" 1>&3
            FOUND_GINAC=false
        fi
    fi
    if ! $FOUNDGINAC ; then
        FOUNDGINAC=`findlib ginac GINAC && findlib cln CLN`
        eval addflag LFLAGS "-L`dirname $CONF_GINAC`"
        eval addflag LFLAGS "-L`dirname $CONF_CLN`"
        eval addflag LFLAGS "-lginac -lcln"
    fi
    if $FOUNDGINAC; then
ulrich_y's avatar
ulrich_y committed
432
        CONF_LD=${LD:-$CONF_CXX}
ulrich_y's avatar
ulrich_y committed
433 434 435 436 437 438 439 440 441 442 443 444 445 446 447
        echo -n "Checking if GiNaC works... " 1>&3
        tee $test.ginac.cpp << _EOF_ 1>&2
#include <ginac/ginac.h>
#include <iostream>
int main() {

    GiNaC::ex ans = GiNaC::G(0.3,0.5,0.7);
    ans -= 0.2876820724517808812+3.1415926535897932385*GiNaC::I;
    ans = GiNaC::abs(ans);
    if (ans<1e-15)
        return 0;
    else
        return 1;
}
_EOF_
ulrich_y's avatar
ulrich_y committed
448
        $CONF_CXX $CONF_CPPFLAGS $CONF_BITS -c $test.ginac.cpp
ulrich_y's avatar
ulrich_y committed
449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468
        $CONF_LD -o $test.ginac $test.ginac.o $CONF_LFLAGS
        ./$test.ginac
        case $? in
            0)
              echo "yes" 1>&3
              eval addflag FFLAGS "-DHAVE_GINAC" ;;
            1)
              echo "no" 1>&3
              exit 1 ;;
            *)
              echo "error running GiNaC" 1>&3
              exit 1 ;;
        esac
    else
        echo "GiNaC could not be found" 1>&3
        exit 1
    fi
fi


ulrich_y's avatar
ulrich_y committed
469 470 471
if $HAVE_GINAC && $HAVE_MCC; then
  eval addflag LFLAGS -lrt
fi
ulrich_y's avatar
ulrich_y committed
472

473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488
if [[ ! -z "$CONF_PKGCONFIG" ]]; then
cat > handyg.pc <<EOF
prefix=$CONF_PREFIX
exec_prefix=\${prefix}
libdir=\${exec_prefix}/lib
includedir=\${prefix}/include

Name: handyG
Description: Numerical evaluation of GPL
Version: 0.1.0
Libs: -L\${libdir} -lhandyg
Cflags: -I\${includedir}
EOF

fi

ulrich_y's avatar
ulrich_y committed
489 490 491 492 493 494 495 496 497 498 499 500
echo "creating makefile" 1>&3


cat  > makefile <<EOF
# Generated through $0 $@ on `date` by `whoami`

AR=ar rcs
FC=$CONF_FC
CC=$CONF_CC
CXX=$CONF_CXX
LD=$CONF_LD
MPREP=$CONF_MPREP
ulrich_y's avatar
ulrich_y committed
501
MATH=$CONF_MATH
ulrich_y's avatar
ulrich_y committed
502 503 504

FFLAGS=$CONF_FFLAGS
CFLAGS=$CONF_CFLAGS
ulrich_y's avatar
ulrich_y committed
505
CPPFLAGS=$CONF_CPPFLAGS
ulrich_y's avatar
ulrich_y committed
506 507 508 509
LFLAGS=$CONF_LFLAGS
MCFLAGS=$CONF_MCC_CFLAGS
MLFLAGS=$CONF_MCC_LFLAGS

ulrich_y's avatar
ulrich_y committed
510 511
PREFIX=$CONF_PREFIX
MMPREFIX=$CONF_MMPREFIX
ulrich_y's avatar
ulrich_y committed
512
MODPATH=$CONF_MODPATH
ulrich_y's avatar
ulrich_y committed
513

ulrich_y's avatar
ulrich_y committed
514

ulrich_y's avatar
ulrich_y committed
515
files=globals.o ieps.o utils.o shuffle.o maths_functions.o mpl_module.o gpl_module.o handyG.o
ulrich_y's avatar
ulrich_y committed
516 517 518
objects = \$(addprefix build/,\$(files))


ulrich_y's avatar
ulrich_y committed
519
all: libhandyg.a ${CONF_MPREP:+handyg} geval test
ulrich_y's avatar
ulrich_y committed
520

ulrich_y's avatar
ulrich_y committed
521
libhandyg.a:\$(objects)
ulrich_y's avatar
ulrich_y committed
522 523 524 525 526 527 528 529
		@echo "AR \$@"
		@\$(AR) \$@ $^

# rules to make object files into /build
build/%.o: src/%.f90
		@echo "F90 \$@"
		@\$(FC) \$(FFLAGS) -c $< -o \$@

ulrich_y's avatar
ulrich_y committed
530 531 532 533
build/%.o: checks/%.f90
		@echo "F90 \$@"
		@\$(FC) \$(FFLAGS) -c $< -o \$@

ulrich_y's avatar
ulrich_y committed
534 535
build/%.o: src/%.cpp
		@echo "C++ \$@"
ulrich_y's avatar
ulrich_y committed
536
		@\$(CC) \$(CPPFLAGS) -c $<  -o \$@
ulrich_y's avatar
ulrich_y committed
537

ulrich_y's avatar
ulrich_y committed
538
geval: libhandyg.a build/geval.o
ulrich_y's avatar
ulrich_y committed
539
		@echo "LD \$@"
ulrich_y's avatar
ulrich_y committed
540
		@\$(LD) -o \$@ build/geval.o -L. -lhandyg \$(LFLAGS)
ulrich_y's avatar
ulrich_y committed
541

ulrich_y's avatar
ulrich_y committed
542 543 544 545 546 547 548
EOF

$HAVE_MCC && cat >> makefile <<EOF
build/%.tm.c: src/%.tm
		@echo "MPREP \$@"
		@\$(MPREP) \$< -o \$@

ulrich_y's avatar
ulrich_y committed
549
build/mathlink.o: build/mathlink.tm.c
ulrich_y's avatar
ulrich_y committed
550 551 552
		@echo "CC \$<"
		@\$(CC) \$(MCFLAGS) \$(CFLAGS) -o \$@ -c \$<

ulrich_y's avatar
ulrich_y committed
553
handyg: build/mathlink.o libhandyg.a
ulrich_y's avatar
ulrich_y committed
554
		@echo "LD \$@"
ulrich_y's avatar
ulrich_y committed
555
		@\$(LD)  \$< libhandyg.a -o \$@ \$(LFLAGS) \$(MLFLAGS)
ulrich_y's avatar
ulrich_y committed
556

ulrich_y's avatar
ulrich_y committed
557 558 559
checks/test-chen.f90: checks/generate.m
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
ulrich_y's avatar
ulrich_y committed
560
checks/test-chenff.f90: checks/generate.m
ulrich_y's avatar
ulrich_y committed
561 562
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
ulrich_y's avatar
ulrich_y committed
563 564 565 566 567 568
checks/test-muone.f90: checks/generate.m
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
checks/test-muoneNP.f90: checks/generate.m
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
ulrich_y's avatar
ulrich_y committed
569 570


ulrich_y's avatar
ulrich_y committed
571 572 573 574 575 576
EOF
echo -n "test: \$(objects) " >> makefile

                            echo -n "build/test-chenref.o " >> makefile
$HAVE_GINAC              && echo -n "build/ginac.o " >> makefile
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-chen.o " >> makefile
ulrich_y's avatar
ulrich_y committed
577
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-chenff.o " >> makefile
ulrich_y's avatar
ulrich_y committed
578 579
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-muone.o " >> makefile
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-muoneNP.o " >> makefile
ulrich_y's avatar
ulrich_y committed
580

ulrich_y's avatar
ulrich_y committed
581 582
echo "build/test.o" >> makefile
cat  >> makefile <<EOF
ulrich_y's avatar
ulrich_y committed
583 584 585
		@echo "LD \$@"
		@\$(LD) -o \$@ $^ \$(LFLAGS)

ulrich_y's avatar
ulrich_y committed
586
install: libhandyg.a build/handyg.mod ${CONF_MPREP:+handyg} geval
ulrich_y's avatar
ulrich_y committed
587
		mkdir -p \$(PREFIX)
ulrich_y's avatar
ulrich_y committed
588
		mkdir -p \$(PREFIX)/bin
ulrich_y's avatar
ulrich_y committed
589
		cp geval \$(PREFIX)/bin/geval
ulrich_y's avatar
ulrich_y committed
590
		mkdir -p \$(PREFIX)/lib
ulrich_y's avatar
ulrich_y committed
591
		cp libhandyg.a \$(PREFIX)/lib/
ulrich_y's avatar
ulrich_y committed
592
		mkdir -p \$(PREFIX)/include
ulrich_y's avatar
ulrich_y committed
593
		cp build/handyg.mod \$(PREFIX)/include/
ulrich_y's avatar
ulrich_y committed
594 595 596
EOF
$HAVE_MCC && cat >> makefile <<EOF
		mkdir -p \$(MMPREFIX)
ulrich_y's avatar
ulrich_y committed
597
		cp handyg \$(MMPREFIX)
ulrich_y's avatar
ulrich_y committed
598
EOF
599 600 601 602 603 604
if [[ ! -z "$CONF_PKGCONFIG" ]]; then
cat >> makefile <<EOF
		mkdir -p \$(PREFIX)/lib/pkgconfig
		cp handyg.pc \$(PREFIX)/lib/pkgconfig
EOF
fi
ulrich_y's avatar
ulrich_y committed
605 606 607 608 609 610 611
if [[ ! -z "$CONF_MODPATH" ]]; then
cat >> makefile <<EOF
		mkdir -p \$(PREFIX)/\$(MODPATH)
		cp build/handyg.mod \$(PREFIX)/\$(MODPATH)
EOF
fi

ulrich_y's avatar
ulrich_y committed
612 613 614

echo "uninstall:" >> makefile
echo -ne "\t\trm -i " >> makefile
ulrich_y's avatar
ulrich_y committed
615 616
echo -n "\$(PREFIX)/lib/libhandyg.a " >> makefile
echo -n "\$(PREFIX)/include/handyg.mod " >> makefile
ulrich_y's avatar
ulrich_y committed
617
echo -n "\$(PREFIX)/bin/geval " >> makefile
ulrich_y's avatar
ulrich_y committed
618
$HAVE_MCC && echo -n "\$(MMPREFIX)/handyg" >> makefile
619 620 621
if [[ ! -z "$CONF_PKGCONFIG" ]]; then
echo -n "\$(PREFIX)/lib/pkgconfig " >> makefile
fi
ulrich_y's avatar
ulrich_y committed
622 623 624
if [[ ! -z "$CONF_MODPATH" ]]; then
echo -n "\$(PREFIX)/\$(MODPATH)/handyg.mod " >> makefile
fi
ulrich_y's avatar
ulrich_y committed
625 626 627
cat  >> makefile <<EOF


ulrich_y's avatar
ulrich_y committed
628 629 630 631 632
check: test
		./$<

clean:
		@rm -f build/*.o build/*.mod build/*.c build/mcc.internals*
ulrich_y's avatar
ulrich_y committed
633
		@rm -f test geval libhandyg.a handyg
ulrich_y's avatar
ulrich_y committed
634
		@rm -f checks/test-chen.f90 checks/test-muone.f90 checks/test-muoneNP.f90
ulrich_y's avatar
ulrich_y committed
635 636 637

distclean:
		@rm -f build/*.o build/*.mod build/*.c build/mcc.internals*
ulrich_y's avatar
ulrich_y committed
638
		@rm -f test geval libhandyg.a handyg
ulrich_y's avatar
ulrich_y committed
639
		@rm -f checks/test-chen.f90 checks/test-muone.f90 checks/test-muoneNP.f90
640
		@rm -f makefile handyg.pc
ulrich_y's avatar
ulrich_y committed
641
EOF